<template>
    <div class="work">
        <v-file-input
            v-model="file"
            show-size
            chips
            :label="$t('Work.LNG_WORK_LABEL')"
            :loading="loading"
            :error="!!errorMsg"
            :error-messages="errorMsg"
            clearable/>
        <div v-if="work && fileName" class="work-infos text-no-wrap text-truncate pb-4">
            {{ fileDate }} : {{ fileName }}
        </div>
        <div class="work-actions">
            <v-btn @click="deleteWork"
                   :disabled="!fileName"
                   outlined
                   color="error"
                   class="mr-1">
                {{ $t("Work.LNG_WORK_DELETE") }}
            </v-btn>
            <v-btn @click="addWork" outlined color="success" class="mr-1">
                {{ $t("Work.LNG_WORK_UPLOAD") }}
            </v-btn>
            <v-btn outlined color="#0ABBEF" :to="{ name: 'Work', params: { taskId: taskId }}">
                {{ $t("Work.LNG_WORK_SHOW") }}
            </v-btn>
        </div>
    </div>
</template>

<script>
import Services from "@/services/api/index";
import { mapGetters } from "vuex";
import dayjs from 'dayjs';
import localizedFormat from "dayjs/plugin/localizedFormat";

export default {
    name: "WorkActions",
    props: {
        taskId: {
            required: true
        }
    },
    data: () => ({
        file: null,
        loading: false,
        work: null,
        errorMsg: null
    }),
    computed: {
        ...mapGetters(['user']),
        fileDate() {
            return dayjs(this.work?.rendering_date).format("LLL");
        },
        fileName() {
            return this.work?.file_name;
        },
    },
    mounted() {
        dayjs.extend(localizedFormat);
        dayjs.locale(this.$i18n.locale);
        this.getWork();
    },
    methods: {
        addWork() {
            if (this.file) {
                this.errorMsg = null;
                this.loading = true;
                let formData = new FormData();
                formData.append('file', this.file);
                formData.append('file_name', this.file.name);
                formData.append('task', this.taskId);
                Services.Work.addWork(formData).then(async res => {
                    switch (res.status) {
                        case 200:
                            this.file = null;
                            this.work = await res.json();
                            break;
                        case 409:
                            this.errorMsg = "Conflict, file already exist...";
                            break;
                    }
                    this.loading = false;
                });
            } else {
                this.errorMsg = "A file is required";
            }
        },
        async deleteWork() {
            this.loading = true;
            let res = await Services.Work.deleteWork(this.work.task_id);
            switch (res.status) {
                case 200:
                    this.file = null;
                    this.work = null;
                    break;
                case 401:
                    this.$router.push({ name: "Login" });
                    break;
            }
            this.loading = false;
        },
        async getWork() {
            let works = await Services.Work.getWork(this.taskId);
            this.work = works.find(w => w.user.name === this.user.name);
        },
    }
}
</script>

<style scoped lang="scss">
.work {
    &-actions {
        width: 100%;
        justify-content: center;
        text-align: center;
    }
}
</style>